//+------------------------------------------------------------------+
//|                                      Previous Highs And Lows.mq4 |
//|                                   Copyright  2005, Jason Rivera |
//|                                      http://www.jasonerivera.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Jason Rivera"
#property link      "http://www.jasonerivera.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 FireBrick
double H=0;
double L=0;
extern int shift_time = 1;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
//---- indicators
   SetIndexLabel(0,"Previous High");
   SetIndexLabel(1,"Previous Low");
   SetIndexStyle(0,DRAW_SECTION, STYLE_SOLID, 3);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_SECTION, STYLE_SOLID, 3);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjectDelete("Prev-High");
   ObjectDelete("Prev-Low");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int pos = Bars-shift_time-1;
   int m = 0;
   int d = 0;
   int y = 0;
   string dt = "";
   datetime some_time = 0;
   int shift = 0;
   int tc = 0;
//----    
   if(Bars - counted_bars == 1) return(0);
   
   if( Bars < shift_time + 1 ) return(0);
   
   if (Period() < 1440)
   {
      tc = 1440;
   }else
   {
      switch (Period())
      {
      case 1440: 
         tc = 10080; 
         break;
      case 10080: 
         tc = 43200; 
         break;
      case 43200: 
         tc = 518400; 
         break;
      }
   }
   if (DayOfWeek()==1)  shift_time=2;
//Print("shift time is ", shift_time); 
   while(pos>=0)
   {
      m=TimeMonth(Time[pos]);
      d=TimeDay(Time[pos]);
      y=TimeYear(Time[pos]);
      dt = y + "." + m + "." + d + " 00:00";
      some_time = StrToTime(dt);
      
      //find the proper shift of the Daily bar having the same date as this timeframe's bar with the current shift
      shift = iBarShift(NULL,tc,some_time); 
      
      H = iHigh(NULL,tc,shift+shift_time);
      L = iLow(NULL,tc,shift+shift_time);
           
      ExtMapBuffer1[pos] = H;
      ExtMapBuffer2[pos] = L; 
      
      if(pos==0) CreateLabels();
      
      pos--;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+

void CreateLabels()
{
   if(ObjectFind("Prev-High")==-1)
   {
      ObjectCreate("Prev-High", OBJ_TEXT, 0, CurTime(), H);
      ObjectSetText("Prev-High", "H", 12, "Verdana", Gray);
   }else {
      ObjectMove("Prev-High", 0, CurTime(), H);
   }      
      
   if(ObjectFind("Prev-Low")==-1)
   {
      ObjectCreate("Prev-Low", OBJ_TEXT, 0, Time[0], L);
      ObjectSetText("Prev-Low", "L", 12, "Verdana", Gray);
   }else {
      ObjectMove("Prev-Low", 0, CurTime(), L);
   }
      
   return(0);

}